Тёмный

DP 27. Longest Common Substring | DP on Strings 🔥 

take U forward
Подписаться 668 тыс.
Просмотров 213 тыс.
50% 1

Lecture Notes/C++/Java Codes: takeuforward.o...
Problem Link: bit.ly/3H2M3KS
Pre-req for this Series: • Re 1. Introduction to ...
a
Make sure to join our telegram group for discussions: linktr.ee/take...
Full Playlist: • Striver's Dynamic Prog...
In this video, we solve the MCM Dp, this is the first problem on the pattern Partition DP.
If you have not yet checked our SDE sheet, you should definitely do it: takeuforward.o...
You can also get in touch with me at my social handles: linktr.ee/take...

Опубликовано:

 

12 сен 2024

Поделиться:

Ссылка:

Скачать:

Готовим ссылку...

Добавить в:

Мой плейлист
Посмотреть позже
Комментарии : 459   
@gandhijainamgunvantkumar6783
@gandhijainamgunvantkumar6783 2 года назад
Amazing explanation brother. if anyone is confused about why we are taking dp[i][j] = 0, note that dp[i][j] here indicates the length of longest substring ending at index i of the s1 and index j of s2 string.
@subasishkar9469
@subasishkar9469 2 года назад
I am not getting the mismatch condition only please can you elaborate
@drj9403
@drj9403 2 года назад
ha bhai thank you 😂
@amansinghdalawat758
@amansinghdalawat758 Год назад
right I needed to confirm with someone
@jayantmishra2266
@jayantmishra2266 Год назад
Small Correction : note that dp[i][j] here indicates the length of longest substring ending at index i-1 of the s1 and index j-1 of s2 string, cause here i and j refers to length of s1 and s2 respectively, so access last char of s1 and s2 we'll do s1[i-1] and s2[j-1].
@SohailKhan-cx9gb
@SohailKhan-cx9gb Год назад
​@@jayantmishra2266yes bro because in tabulation we cannot write the negative condition so we have shifted i-1 to i
@chandanbera2692
@chandanbera2692 2 года назад
Recursion solution static int lcs(int m, int n, String s1, String s2, int count) { if(m
@parthsalat
@parthsalat 2 года назад
Dev manus 🙏
@ankitparashar8730
@ankitparashar8730 2 года назад
By memorization it takes cubic time complexity
@user-fy4uq4lw8l
@user-fy4uq4lw8l 8 месяцев назад
Just pointed out We can ignore the base case and else condition . it still works as the dp array is initially filled with with zero only. So no need to again assign 0 to it.
@tawhidjoarder756
@tawhidjoarder756 2 года назад
This guy really deserves a medal.
@himanshuagrawal8012
@himanshuagrawal8012 2 года назад
#UNDERSTOOD Bhaiya...I am now able to develop logic before watching the video...still I watch video after submitting just to go through once and to see your energy level...🙂🙂😍😍
@divyendragahlot9231
@divyendragahlot9231 2 года назад
You should have told the recursive approach too. You had done that in all the previous videos.
@vikasbelida3218
@vikasbelida3218 Год назад
here's the recursive solution: public int lcs(int[] A, int[] B, int m, int n, int res) { if (m == -1 || n == -1) { return res; } if (A[m] == B[n]) { res = lcs(A, B, m - 1, n - 1, res + 1); } return max(res, max(lcs(A, B, m, n - 1, 0), lcs(A, B, m - 1, n, 0))); }
@rishabhgupta9846
@rishabhgupta9846 Год назад
@@vikasbelida3218 can you share memoization one also ,I'm not able to do it
@ravianand3498
@ravianand3498 Год назад
@@allideas777 res is also changing so that also needs to be considered in dp table,so there are 3 parameters therefore 3D array is needed.
@datahacker1405
@datahacker1405 Год назад
Only real programmers can do that because you won't find recursive approach at most of the places. Most of these youtubers understand the omnipresent solution and explain it here with a few additions here and there.
@av21015
@av21015 Год назад
@@datahacker1405 is it even possible to solve this using memoization? I tried but couldn't
@shaileshsingh6771
@shaileshsingh6771 Год назад
We can space optimize it to 1D array:- int findLength(vector& nums1, vector& nums2) { int n = nums1.size(), m = nums2.size(); int maxLength = 0; vector prev(m+1,0); for(int i=1; i0; j--) { if(nums1[i-1] == nums2[j-1]) { prev[j] = 1 + prev[j-1]; maxLength = max(maxLength,prev[j]); } else prev[j] = 0; } } return maxLength; }
@rossgeller9372
@rossgeller9372 Год назад
if anyone wants a recursive approach for this, here it is-> src: int lcsHelper(string &str1, string &str2, int n, int m, int count){ if (m == -1 || n == -1){ return count; } if (str1[n] == str2[m]){ count = lcsHelper(str1, str2, n - 1, m - 1, count + 1); } count = max({count, lcsHelper(str1, str2, n - 1, m, 0), lcsHelper(str1, str2, n, m - 1, 0)}); return count; } int lcs(string &str1, string &str2){ return lcsHelper(str1, str2, str1.length() - 1, str2.length() - 1, 0); }
@ravindrayadav6103
@ravindrayadav6103 Год назад
why this memoization code gives wrng ans-//{ Driver Code Starts #include using namespace std; // } Driver Code Ends class Solution{ public: int dp[1001][1001]; int solve(string S1,string S2,int n,int m,int cnt){ if(n==-1||m==-1)return cnt; if(dp[n][m]!=-1)return dp[n][m]; if(S1[n]==S2[m]){ cnt= solve(S1,S2,n-1,m-1,cnt+1);} else{ cnt= max({cnt,solve(S1,S2,n-1,m,0),solve(S1,S2,n,m-1,0)}); } return dp[n][m]=cnt; } int longestCommonSubstr (string S1, string S2, int n, int m) { memset(dp,-1,sizeof(dp)); int cnt=0; return solve(S1,S2,n-1,m-1,0); } }; //{ Driver Code Starts. int main() { int t; cin >> t; while (t--) { int n, m; cin >> n >> m; string s1, s2; cin >> s1 >> s2; Solution ob; cout
@riteshmohan3454
@riteshmohan3454 Год назад
mr geller i thought you were a paleontologist
@justice5777
@justice5777 Год назад
@@riteshmohan3454 yeah i also thought he's a polontologist
@naamhaii
@naamhaii 11 месяцев назад
memoization is not work on this
@naamhaii
@naamhaii 11 месяцев назад
@@ravindrayadav6103 not working on these TC 1)yxyy yxy ans->3 2)yxxzzxxxx yzyzxxyxxz ans->4
@sanginigupta1312
@sanginigupta1312 2 года назад
Here, arr[i][j] can mean the longest substring that ends at ith character in string 1 and at jth character in string 2, and we take the max of all the combinations!
@gsampath8017
@gsampath8017 2 года назад
from where have you learned dsa ?? if you have not understood a specific topic how to handle it??
@alexrcrew1975
@alexrcrew1975 2 года назад
search is the only solution go n search
@wrongnotes1157
@wrongnotes1157 Год назад
here is the memorization method: int lcsUtil(string& s1, string& s2, int n, int m, vector& dp) { if (n == 0 || m == 0) { return 0; } if (dp[n][m] != -1) { return dp[n][m]; } int result = 0; if (s1[n-1] == s2[m-1]) { result = 1 + lcsUtil(s1, s2, n-1, m-1, dp); } else { result = 0; } dp[n][m] = result; return result; } int lcs(string& s1, string& s2) { int n = s1.size(); int m = s2.size(); vector dp(n+1, vector(m+1, -1)); int ans = 0; for (int i = 1; i
@anshumaan1024
@anshumaan1024 Год назад
nice brother this is working
@ishanporwal4403
@ishanporwal4403 Год назад
how is it different from the brute force as this also has TC O(n^3) ans the TC of brute force id also O(n^3)
@SohailKhan-cx9gb
@SohailKhan-cx9gb Год назад
Same bro 🤜
@vinaykumar9002
@vinaykumar9002 Год назад
Equivalent leetcode question for this is "718. Maximum Length of Repeated Subarray "
@itslol6504
@itslol6504 Год назад
Thanks !
@user-ie8sy7wo4m
@user-ie8sy7wo4m Год назад
Thanks man. Appreciated.
@rohitanjane1668
@rohitanjane1668 Год назад
Thanks bro...👍🏻
@munnakrish3572
@munnakrish3572 2 года назад
understood!..Thanks for explaining this in an elegant way!
@stith_pragya
@stith_pragya 8 месяцев назад
UNDERSTOOD.........Thank You So Much for this wonderful video........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@parthib_deb23
@parthib_deb23 19 дней назад
make a well-built hashmap and check within it. Its possible to do in O(N) time. There is a simple reason behind it - In subsequence the order of words doesnot matter which makes the solution prone to more edgecases but in substring , even if there is one single character unmatched you can't go forward
@harshitsen5479
@harshitsen5479 Год назад
In the no-matching condition in the case of subsequence we were basically skipping one element from the str1 in the first recursion call and one element from the str2 in the second recursion call (since subsequence can be or cannot be continous), but in the case of substring we cannot skip an element to form a substring (as it must be continous). So that's why we returned 0 straight away.
@LORDGULSHAN
@LORDGULSHAN 2 года назад
Striver, Please make a video on how to print Longest Palindromic Substring, because reversing the string technique won't work like we did for Longest Palindromic Subsequence.
@papayasprout
@papayasprout 2 года назад
Why will it not work?
@lokeshdohare2579
@lokeshdohare2579 2 года назад
@@papayasprout Because this approach will fails when there exists a reversed copy of a non-palindromic substring in some other part of our original string. Ex - "aacdacaa"
@omkumarsingh4194
@omkumarsingh4194 Год назад
@@lokeshdohare2579 i am facing the same problem, did u come up with any modification over striver's code
@lokeshdohare4872
@lokeshdohare4872 Год назад
@@omkumarsingh4194 I came up with a solution, but that's not a dp solution.
@omkumarsingh4194
@omkumarsingh4194 Год назад
@@lokeshdohare4872 alright, can u share that. Btw I solved using same dp by striver . Just introduced one condition when u are updating ans that is I-dp[I][j] == n-j. Means we are checking whether startpoint of both substrings is same
@ShubhamVerma-hw4uj
@ShubhamVerma-hw4uj 2 года назад
for those who want to solve this question on leetcode, it is lc 718
@codecrafts5263
@codecrafts5263 8 месяцев назад
thanks!
@dadidivya8663
@dadidivya8663 2 года назад
Just in case if anyone needs recursive approach for this: Recursive code: def lcs(s, t) : def solve(i1,i2): if(i1
@ScrollWthMahadev
@ScrollWthMahadev Год назад
best
@KunalJaiswal-og7nf
@KunalJaiswal-og7nf Год назад
@@ScrollWthMahadev can convert to c++??
@sharmaanuj334
@sharmaanuj334 Год назад
Hey, I am not able to understand why you have done nomatch = min(solve(), solve(), 0) since it would always give 0 for nomatch
@tejaswi4650
@tejaswi4650 8 месяцев назад
same question@@sharmaanuj334
@raghavmanish24
@raghavmanish24 26 дней назад
this question like one of the easiest question after following your videos....thanku striver
@nitin50056
@nitin50056 2 года назад
Can you share a memoization solution ?
@shuvbhowmickbestin
@shuvbhowmickbestin Месяц назад
is there a reason why we're not talking about the memoization approach here? I kinda know the answer but it'd be better if the memoization approach is also discussed or told why it is not being considered for this problem because we always go from recursion to memoization to tabulation. This is the right approach for solving DP problems.
@aakashbhandari9761
@aakashbhandari9761 9 месяцев назад
Sir understood Well! , But just want to ask is the below code is right ? String a="aakabdqwer"; String b="abkasxgdqwer"; int i=a.length()-1; int j=b.length()-1; int count=0; int ans=0; while(i>= 0 && j>= 0){ if(a.charAt(i)==b.charAt(j)){ count ++; i--; j--; }else{ count=0; i--; j--; } ans=Math.max(count,ans); } System.out.println(ans);
@vikasbelida3218
@vikasbelida3218 Год назад
incase anyone looking for recursive solution: public int lcs(int[] A, int[] B, int m, int n, int res) { if (m == -1 || n == -1) { return res; } if (A[m] == B[n]) { res = lcs(A, B, m - 1, n - 1, res + 1); } return max(res, max(lcs(A, B, m, n - 1, 0), lcs(A, B, m - 1, n, 0))); }
@madhukartemba2987
@madhukartemba2987 2 года назад
Striver sir, this problem can also be solved by using just one array by traversing from the back: import java.util.*; public class Solution { public static int lcs(String str1, String str2) { int n1 = str1.length(); int n2 = str2.length(); int prev[] = new int[n2+1]; int ans = 0; for(int i=1; i0; j--) { if(str1.charAt(i-1)==str2.charAt(j-1)) { prev[j] = 1 + prev[j-1]; } else { prev[j] = 0; } ans = Math.max(ans, prev[j]); } } return ans; } }
@harshjain8823
@harshjain8823 2 года назад
How its working ? what is the intuition ..
@ayonsinha2075
@ayonsinha2075 Год назад
@@harshjain8823 it's just 1d conversion of 2 individual 1d ..and for curr in matching condition curr[index2]= prev[index2-1]...so u just nedd prev[index2-1] so...u can rewrite on prev array itself from n2 to 0 because for current index u only need value of just previous index..so u can easily rewrite it..
@thanushreddy1020
@thanushreddy1020 Месяц назад
Understood !! Thank You, for your hard work..
@prabhakaran5542
@prabhakaran5542 5 месяцев назад
Understood ❤
@ranasauravsingh
@ranasauravsingh 2 года назад
UNDERSTOOD...!! Thank you striver for the video... :)
@dhairyachauhan6622
@dhairyachauhan6622 Год назад
using recursion c++ #include int solve(int n, int m, string &s1, string &s2, int count){ if(n == 0 || m == 0){ return count; } if(s1[n-1]==s2[m-1]){ count = solve(n-1, m-1, s1, s2, count+1); } int count2 = solve(n, m-1, s1, s2, 0); int count3 = solve(n-1, m, s1, s2, 0); return max(count, max(count2, count3)); } int lcs(string &str1, string &str2){ return solve(str1.length(), str2.length(), str1, str2, 0); }
@ITACHIUCHIHA-dr8sz
@ITACHIUCHIHA-dr8sz Год назад
what about memoization ?
@tasneemayham974
@tasneemayham974 11 месяцев назад
UNDERSTOOOD UNDERSTOOOD UNDERSTOOOD!!! BEST TEACHERRRR EVERRRRR!!!!!!!!💯💯💯💯
@souvikbiswas284
@souvikbiswas284 13 дней назад
Dropping Single Row Optimization for anyone in need: m, n = len(text1), len(text2) prev = curr = [0]*(n+1) max_len = 0 for i in range(1, m+1): prev_j_min_1 = prev[0] for j in range(1, n+1): ans = prev_j_min_1 + 1 if text1[i-1] == text2[j-1] else 0 prev_j_min_1 = prev[j] curr[j] = ans max_len = max(max_len, curr[j]) return max_len
@parthib_deb23
@parthib_deb23 18 дней назад
class Solution: def findLength(self, nums1: list[str], nums2: list[str]) -> int: if nums1==nums2: print(len(nums1)) elif nums1==[] or nums2==[]: print(0) elif nums1==nums2[::-1]: count=1 for i in range(1,len(nums1)): if nums1[i]==nums1[i-1]: count+=1 return count else: map={nums1[i]:set() for i in range(len(nums1))} map[nums1[0]].add(nums1[0]) for i in range(1,len(nums1)): map[nums1[i]].add(nums1[i-1]) print(map) temp_iter=[] temp=0 final=[] count=0 for i in range(len(nums2)): if nums2[i] in map.keys(): if temp==0: temp=1 else: if nums2[i-1] in map[nums1[i]]: if nums2[i-1] not in temp_iter: temp_iter.append(nums2[i-1]) temp_iter.append(nums2[i]) temp+=1 else: if temp>count: final=temp_iter count=temp temp=0 temp_iter=[] return count print(Solution().findLength(['1','2','3','2','1'],['3','2','1','4','7'])) print(Solution().findLength(['0','0',1],['1','0','0'])) this is the approach
@maradanikhil6882
@maradanikhil6882 Год назад
here is the recursive & memoization approach.......... // recursive int func(int ind1,int ind2,string &s1,string &s2,int &ans){ if(ind1
@anshumaan1024
@anshumaan1024 Год назад
Bhai aapka memoization ka code toh pura recursive hai, joh aapne dp[][] array pass krri hai uska kuch use hi nhi hai recursive code shi lga 🙂
@maradanikhil6882
@maradanikhil6882 Год назад
@@anshumaan1024 you are correct bro, return dp[ind1][ind2]=match ; now,it will be working fine ,thanks
@kushalgupta2041
@kushalgupta2041 21 день назад
@@maradanikhil6882 na bro it will give you wrong answer try it and even if you want to do it recursive way the time complexity will be like brute force
@ritikshandilya7075
@ritikshandilya7075 2 месяца назад
Thanks for great solution Striver
@FunkyPanda6263
@FunkyPanda6263 Год назад
1-Array space optimised solution. int lcs(string &s1, string &s2){ int len1 = s1.length(), len2 = s2.length(); vector state(len2+1); int prev = 0; int temp, res = 0; for(int i=1; i
@KCODivyanshuKatyan
@KCODivyanshuKatyan 2 года назад
The energy man 🙌🔥
@UECAshutoshKumar
@UECAshutoshKumar 2 месяца назад
Thank You Understood!!!
@vattiyeshwanth282
@vattiyeshwanth282 2 месяца назад
so here dp[i][j] indicates that longest common substring in which s1[i] and s2[j] are matching?
@kushagramishra3026
@kushagramishra3026 2 года назад
Understood
@CryptoZombie666
@CryptoZombie666 2 месяца назад
UNDERSTOOD, Striver Bhaiya! Here's Another Brute force method WITHOUT USING DP: int lcs(string &str1, string &str2){ int n = str1.size(), m = str2.size(), maxLen = 0; for(int i = 0; i < n; i++) { for(int j = 0; j < m; j++) { if(str1[i] == str2[j]){ int ptr1 = i, ptr2 = j; int currLen = 0; while(ptr1 < n && ptr2 < m && str1[ptr1] == str2[ptr2]){ currLen++; ptr1++, ptr2++; } maxLen = max(maxLen, currLen); } } } return maxLen; }
@pulkitagrawal6042
@pulkitagrawal6042 2 года назад
Memoization solution is not giving correct answer even though i have made the required chages in it.
@SumanSingh-gq5vn
@SumanSingh-gq5vn 3 месяца назад
ye wala clear nhi hua striver bro! ...isme dikkat aai approach m mujhe ...koi samjha sake to please samjhao mujhe
@rlm3227
@rlm3227 12 дней назад
I used to think, this is a. good hard problem, but turns out this is just a 1000 rated problem on CF
@rohandas6298
@rohandas6298 9 месяцев назад
Single 1D Array space optimization: int lcs(string &s, string &t){ int n=s.size(),m=t.size(); vector cur(m+1,0); int maxi=0; for(int i=1;i
@devbhojani9274
@devbhojani9274 4 месяца назад
why aren't we doing this with the two pointer approach?? we can have total of four pointers... two pointers for the first string and another two pointers for the second string... I tried using this approach and 41 test cases passed out of 50 on code ninjas(code 360)... now I don't know which edge case I am missing...
@DevashishJose
@DevashishJose 8 месяцев назад
Understood, Thank you so much.
@mohitsingh13
@mohitsingh13 9 дней назад
Understood ❤🔥🔥
@InbasekaranP
@InbasekaranP 2 года назад
Hey striver, this method of finding the longest common substring fails when there exists a reversed copy of a non-palindromic substring in some other part of S. S = “abacdfgdcaba”, S’ = “abacdgfdcaba”. The longest common substring between S and S’ is “abacd”. This is not a valid palindrome. As there is a reverse copy of "abcd" ie "dcaba" which is non-palindromic substring in some other part of S, the longest common substring method fails. To fix this we just need to check if the substring’s indices are the same as the reversed substring’s original indices. If it is, then we attempt to update the longest palindrome found so far; if not, we skip this and find the next candidate. Here is the modified code for the above question: ```cpp class Solution { public: string longestPalindrome(string a) { int n = a.length(); string b = {a.rbegin(),a.rend()}; pair ans = {INT_MIN,{-1,-1}}; vector dp(n+1,vector(n+1,0)); for(int i = 1;i
@hardikjain6397
@hardikjain6397 2 года назад
Thanks bro. It helped
@mohitsoni2919
@mohitsoni2919 2 года назад
For striver code as well we are getting lcs as 5 bro
@dheerajolakkal4268
@dheerajolakkal4268 4 месяца назад
How are ppl coming with such simple solutions
@aruna5869
@aruna5869 6 месяцев назад
understood :)❤ still we can optimise this to one array by a loop m to 1
@sparshyadav9709
@sparshyadav9709 Месяц назад
Understood.
@yugal8627
@yugal8627 Год назад
I got the intuition within 4mins of you video.😎😎
@googleit2490
@googleit2490 10 месяцев назад
Done and dusted in the revision session :) Nov'14, 2023 04:37 pm
@tusharsahu907
@tusharsahu907 2 года назад
understood …excellent series
@manjunathg.s5967
@manjunathg.s5967 2 года назад
Understood!!
@_ShouravChy
@_ShouravChy 5 месяцев назад
Printing the LCS: #include using namespace std; int main() { string s1,s2; cin>>s1>>s2; int n= s1.size(); int m = s2.size(); vectordp(n+1,vector(m,0)); int res = 0; int startIdx = -1, endIdx = -1; int st = INT_MAX; for(int i=1;i
@samarthsinghthakur
@samarthsinghthakur Год назад
If someone can clear my doubt. Can someone tell me what does dp[ i ][ j ] means? --- dp[ 1 ][ 2 ] is 0 What does dp[ 1 ][ 2 ] means here? What the longest common substring where i = 1 and j = 2; ie str1 = "a" and str2 = "ab" I am certain that's not the meaning here since dp[ 1 ][ 2 ] is 0 . ---
@State_exam_preparation
@State_exam_preparation 11 месяцев назад
Dp[1][2] means a from str1 and b from str2. So a and b is not substring so O
@koocheukkeijacky9704
@koocheukkeijacky9704 10 месяцев назад
amazing teacher.
@muchmunchies43
@muchmunchies43 2 месяца назад
Understood!
@codenchill732
@codenchill732 2 года назад
Consistency 🔥
@Hrushi_2000
@Hrushi_2000 11 месяцев назад
Understood. Thankyou Sir
@animeshkumar2683
@animeshkumar2683 25 дней назад
Understood
@prashantkumar-hx1dv
@prashantkumar-hx1dv 2 года назад
cool man
@theresilientpianist7114
@theresilientpianist7114 Месяц назад
understood.
@original_gangsta_
@original_gangsta_ 2 года назад
UNDERSTOOD💯💯💯
@yeswanthh5068
@yeswanthh5068 2 года назад
Understood 🙂🙂💚🙏
@Manish_Sahu
@Manish_Sahu 2 года назад
understood
@vidyasagarrvsr3723
@vidyasagarrvsr3723 Год назад
Hey ,i have a doubt according to this code logic, dp[2][2] will get 2 rightt?how zero??? since str1[1]==str2[1] and there is condition to check str1[i]==str2[j]
@rahultiwari7714
@rahultiwari7714 2 года назад
understood bhayiya as always thank u for all
@shivisingh9975
@shivisingh9975 5 месяцев назад
Understood sir!
@hashcodez757
@hashcodez757 5 месяцев назад
Understood Bhaiya!! Edit after 4 months - "UNDERSTOOD BHAIYA!!"
@harshrajputmusic174
@harshrajputmusic174 4 месяца назад
how will we solve this using recursion, memoization?
@priyagrajsharma9390
@priyagrajsharma9390 Год назад
Which board ?? Approach explanation k liye Jo board ya application use ki h konsi h ?
@sumitgupta310
@sumitgupta310 2 месяца назад
understood striver
@shivamnagar9368
@shivamnagar9368 2 года назад
Hey Striver, i m getting wrong ans in java code in space optimization, same happened with lcs space optimization
@nimeshsingh6229
@nimeshsingh6229 2 года назад
I think this can not be solved by memoization ie: top-down won't work here ?? please reply
@anshumaan1024
@anshumaan1024 Год назад
I have searched the whole comment section, i couldn't find any memoized code which has passed all test cases ig you are right
@kushalappaca5324
@kushalappaca5324 2 года назад
Give the recursive solution to this..
@anshumaan1024
@anshumaan1024 Год назад
class Solution{ public: int f(int i, int j, string &s1, string &s2, int &ans){ if( i
@tejasghone5118
@tejasghone5118 2 года назад
Can also be done in O(1) space if we just traverse along the diagonals and keep max consecutive match count
@takeUforward
@takeUforward 2 года назад
Nah nah, you need the previous values as well.. as in case its not matching. You need to know max!
@tejasghone5118
@tejasghone5118 2 года назад
@@takeUforward int ans=0; // diagonals starting from first row for(int i=0;i
@dipaligangawane980
@dipaligangawane980 2 года назад
Very good explanation. Thank you so much.
@joshua_dlima
@joshua_dlima 2 года назад
lovely explanation, thanks!
@comps_52_mankritsingh84
@comps_52_mankritsingh84 2 года назад
Can someone please help me in printing the substring.For some reason I am getting the wrong answer while printing the string. Thank you.
@sufiyan0211
@sufiyan0211 Год назад
Amazing observation!
@SohailKhan-cx9gb
@SohailKhan-cx9gb Год назад
Understood bro but the memoization and recursion is quite tough in recursion there is 3d have made😅
@ratinderpalsingh5909
@ratinderpalsingh5909 2 года назад
Understood, sir. Thank you very much.
@zhunzargulhane6741
@zhunzargulhane6741 8 месяцев назад
In space optimization why do we take the length of prev and curr as length of str2.length()+1 why not str1.length()+1.
@uday_berad
@uday_berad 6 месяцев назад
// memoization in C++ class Solution { vector dp; public: int rec(int i,int j,vector& nums1, vector& nums2,int &ans){ if(i
@codingwithanonymous890
@codingwithanonymous890 2 года назад
has anyone done by memoization (top down)?
@takeUforward
@takeUforward 2 года назад
u cannot u need to carry an extra variable!
@ShivamMishra-kn8zf
@ShivamMishra-kn8zf 2 года назад
@@takeUforward it will be complex but we can do it by third variable right?
@surajjoshi3433
@surajjoshi3433 2 года назад
Suppose the interviewer asked me this particular question , then firstfall i will explain him the subsequence code and what does the table denotes and then this logic. right?? If i will directly jump into this particular logic then he/she will think i memoize the solution!
@dheerajshukla7008
@dheerajshukla7008 2 месяца назад
understood sir
@tharungr7701
@tharungr7701 2 месяца назад
code for printing longest common substring #include using namespace std; void lcs(string str1, string str2) { int n =str1.size(); int m= str1.size(); vectordp(n+1, vector(m+1,0)); int row=0; int col =0; int maxi = 0; for(int i=1; i
@iamnoob7593
@iamnoob7593 8 месяцев назад
US striver
@vaibhavgarad7091
@vaibhavgarad7091 2 года назад
Great video bhaiya
@subasishkar9469
@subasishkar9469 2 года назад
Hi @striver I am not getting the mismatch condition why we are using 0 in this case and have been stuck at it for quite some days now please can you explain , really stuck at this condition
@kumarpurushottam632
@kumarpurushottam632 Год назад
Understood Thanks 😀
@explainedmathmaticsranjeet1404
can we further optimize in 1 d araay?
@NARUTOUZUMAKI-bk4nx
@NARUTOUZUMAKI-bk4nx 9 месяцев назад
UNDERSTOOD
@sauravchandra10
@sauravchandra10 Год назад
Understood, thanks!
@raj_kundalia
@raj_kundalia 2 года назад
Thanks for the video!
@dipanshugupta6995
@dipanshugupta6995 Год назад
thanks a lot sir for the playlist
@p38_amankuldeep75
@p38_amankuldeep75 Год назад
understood very well
@udaypratapsingh8923
@udaypratapsingh8923 Год назад
done with it ! moving to next
Далее
DP 28. Longest Palindromic Subsequence
9:38
Просмотров 244 тыс.
8 patterns to solve 80% Leetcode problems
7:30
Просмотров 353 тыс.
DP 26. Print Longest Common Subsequence | Dp on Strings
16:55
L15. Sudoko Solver | Backtracking
26:10
Просмотров 269 тыс.
I gave 127 interviews. Top 5 Algorithms they asked me.
8:36